import { feature } from 'topojson';
import { csv, json } from 'd3';
 
export const loadAndProcessData = () => 
  Promise
		.all([
        csv('https://vizhub.com/curran/datasets/un-population-estimates-2017-medium-variant.csv'),
        json('https://cdn.jsdelivr.net/npm/world-atlas@2/countries-110m.json')
      ])
		.then(([unData, topoJsonData]) => {      
      const rowById = {};
			unData.forEach(d => {
			rowById[d['Country code']]=d;
			});

      const countries = feature(topoJsonData, topoJsonData.objects.countries);			
			
      countries.features.forEach(d => {
        Object.assign(d.properties, rowById[+d.id]);
    	});
      
      const featuresWithPopulation = countries.features
      	.filter(d => d.properties['2018'])
      	.map(d => {
        	d.properties['2018']= +d.properties['2018'].replace(/ /g, '')*1000
          return d;
        })
      
      return {
      features: countries.features,
      featuresWithPopulation
      };
  });